﻿using System;
using System.Collections.Generic;
using System.Linq;
using MongoDB.Bson;
using MongoDB.Driver;
using MongoDB.Driver.Linq;
using System.Configuration;

namespace MongoDB_Linq
{

    public class AcessoMongo
    {
        static Contato _contato;

        public static string ConnectionString
        {
            get
            {
                return ConfigurationManager.AppSettings["stringConexaoMongoDB"];
            }
        }

        public void CriarDados()
        {
            CriarContatos();
        }

        public void CriarContato(string nome, string email, int idade)
        {
            MongoClient cliente = new MongoClient(ConnectionString);
            MongoServer server = cliente.GetServer();
            MongoDatabase database = server.GetDatabase("MongoLinq");

            var colecao = database.GetCollection<Contato>("Contatos");

            BsonDocument contato = new BsonDocument {
                        { "Nome", nome },
                        { "Email", email },
                        { "Idade", idade }
                        };

            colecao.Insert(contato);
        }

        private static void CriarContatos()
        {
            try
            {
                MongoClient cliente = new MongoClient(ConnectionString);
                MongoServer server = cliente.GetServer();
                MongoDatabase database = server.GetDatabase("MongoLinq");

                var colecao = database.GetCollection<Contato>("Contatos");

                _contato = new Contato
                {
                    Nome = "Jose Carlos",
                    Email = "macoratti@yahoo.com",
                    Idade = 45
                };
                colecao.Insert(_contato);
                _contato = new Contato
                {
                    Nome = "Miriam",
                    Email = "miriamsq@bol.com.br",
                    Idade = 38
                };
                colecao.Insert(_contato);
                _contato = new Contato
                {
                    Nome = "Jefferson",
                    Email = "jeff@net.com.br",
                    Idade = 20
                };
                colecao.Insert(_contato);
                _contato = new Contato
                {
                    Nome = "Yuri",
                    Email = "yuri@net.com.br",
                    Idade = 18
                };
                colecao.Insert(_contato);
                _contato = new Contato
                {
                    Nome = "Bianca",
                    Email = "bibi@uol.com.br",
                    Idade = 16
                };
                colecao.Insert(_contato);
                _contato = new Contato
                {
                    Nome = "Janice",
                    Email = "janjan@uol.com.br",
                    Idade = 18
                };
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public IEnumerable<Contato> GetTodosContatos()
        {
            MongoClient cliente = new MongoClient(ConnectionString);
            MongoServer server = cliente.GetServer();
            MongoDatabase database = server.GetDatabase("MongoLinq");

            var contatosLista = database.GetCollection<Contato>("Contatos");

            var query = from e in contatosLista.AsQueryable<Contato>()
                        select e;

            return query;
        }

        public IEnumerable<Contato> GetContatosPorNome(string nome)
        {
            MongoClient cliente = new MongoClient(ConnectionString);
            MongoServer server = cliente.GetServer();
            MongoDatabase database = server.GetDatabase("MongoLinq");

            var contatosLista = database.GetCollection<Contato>("Contatos");

            var query = from e in contatosLista.AsQueryable<Contato>()
                        where e.Nome == nome
                        select e;

            return query;
        }
       
    }
}
